#include "mex.h"
#include "ANN.h"

// This is the MEX implementation of the MATLAB function 'annkdtree_build'.
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    // Verify the correctness of the number of input and output parameters as well as their type:
    if(nlhs != 1 || nrhs != 1 || !mxIsSingle(prhs[0])) mexErrMsgTxt("Incorrect Sintax\n\ttree = annkdtree_build(A), where A is a SINGLE PRECISION matrix\n");

    // Get pointer to the input matrix of data points:
    float* datapoints = (float*) mxGetData(prhs[0]);
    
    long ptCount = mxGetM(prhs[0]);
    int  dims    = mxGetN(prhs[0]);
    
    // Allocate and store the data points:
	ANNpointArray dataPts = annAllocPts(ptCount, dims);
    long k = 0;
    for(int j=0; j<dims; j++)
	    for(int i=0; i<ptCount; i++)
            dataPts[i][j] = datapoints[k++];

    // Create the kd-tree:
	ANNkd_tree* tree = new ANNkd_tree(dataPts, ptCount, dims);
    
    // Return a pointer to the created tree:
    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    double* pointer_to_tree = mxGetPr(plhs[0]);
    pointer_to_tree[0] = (long) tree;
}
